using System.Net;
using System.Net.Http.Headers;
using System.Text;

using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Http.Features;
using Microsoft.AspNetCore.Mvc;

var builder = WebApplication.CreateBuilder(args);

// Add services to the container.

builder.Services.AddControllers();
// Learn more about configuring Swagger/OpenAPI at https://aka.ms/aspnetcore/swashbuckle
builder.Services.AddEndpointsApiExplorer();
builder.Services.AddSwaggerGen();

var app = builder.Build();
// Configure the HTTP request pipeline.
if (app.Environment.IsDevelopment())
{
    app.UseSwagger();
    app.UseSwaggerUI();
}
app.UseHttpsRedirection();

app.UseAuthorization();

app.MapControllers();


const string selfdocpath = "D:\\Web";
app.MapGet("/",(HttpContext context) =>
{
    byte[] data = File.ReadAllBytes("D:\\Web\\main.html");
    context.Response.Body.WriteAsync(data, 0, data.Length);
});

app.Run();
/*

<!DOCTYPE html>
<html>
<head>
<style type="text/css" >
 #master 
 {
       position:absolute;
      left:50%;
      bottom:0;
      text-align :center;
}
</style>
</head>
<head>
<meta charset=\"utf-8\">
<title>PDB</title>
</head>
<body>
<h1>PDB</h1>
<p>һ΢ٷpdbͬķļ</p>
<p>ڴ½ʹ,ӵиķٶ,͵ӳ</p>
<p>ṩĵַ,Խ뵽Ļ(_NT_SYMBOL_PATH)</p>
<p>http://www.sym101.com/download/symbols</p>
</body>
<div id="master" >
<footer><a href= "https://beian.miit.gov.cn/" target="_blank">ICP2022000729</a></footer>
 </div>
</html>
*/